Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1060909 - Review Request: socket_wrapper - A library passing all socket communications trough unix sockets
Summary: Review Request: socket_wrapper - A library passing all socket communications ...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jakub Hrozek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-02-03 21:46 UTC by Andreas Schneider
Modified: 2014-08-22 19:16 UTC (History)
5 users (show)

Fixed In Version: socket_wrapper-1.1.0-2.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-08-22 19:16:00 UTC
jhrozek: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Andreas Schneider 2014-02-03 21:46:45 UTC
Spec URL: http://xor.cryptomilk.org/rpm/socket_wrapper/socket_wrapper.spec
SRPM URL: http://xor.cryptomilk.org/rpm/socket_wrapper/socket_wrapper-1.0.0-1.fc20.src.rpm
Description: socket_wrapper aims to help client/server software development teams willing to
gain full functional test coverage. It makes possible to run several instances
of the full software stack on the same machine and perform locally functional
testing of complex network configurations.

Fedora Account System Username: asn

NOTE: This is a special library you load with LD_PRELOAD. There is no header file and it will not be linked against any library!

Comment 1 Jakub Hrozek 2014-02-04 10:22:52 UTC
Koji build went fine:
http://koji.fedoraproject.org/koji/taskinfo?taskID=6488651

The package looks good and works as advertised.

Here is a full rpmlint output:
libsocket_wrapper.x86_64: W: spelling-error Summary(en_US) unix -> UNIX, Unix, uni
libsocket_wrapper.x86_64: W: shared-lib-calls-exit /usr/lib64/libsocket_wrapper.so.0.0.1 exit@GLIBC_2.2.5
libsocket_wrapper.x86_64: W: devel-file-in-non-devel-package /usr/lib64/pkgconfig/socket_wrapper.pc
libsocket_wrapper.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libsocket_wrapper.so

You might want to fix the first warning. The rest are understandable since this is a library to be dlopened, not linked against.

The tarball is different from upstream, which is something that needs to be fixed. The rest is OK. I'll post a fedora-review in a separate comment.

Comment 2 Jakub Hrozek 2014-02-04 10:23:32 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Development (unversioned) .so files in -devel subpackage, if present.
  Note: Unversioned so-files directly in %_libdir.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages
  ---> False positive. This is understandable given the libraries are
       supposed to be dlopened

- Sources used to build the package match the upstream source, as provided in
  the spec URL.
  Note: Upstream MD5sum check error, diff is in
  /home/remote/jhrozek/rpmbuild/SRPMS/socket_wrapper/diff.txt
  See: http://fedoraproject.org/wiki/Packaging/SourceURL
  ---> This needs to be fixed

===== MUST items =====

C/C++:
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[X]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib64/pkgconfig(pkgconfig),
     /usr/lib64/cmake(cmake)
     ----> This allows the package to be installed even without pkgconfig
           or cmake
[x]: %build honors applicable compiler flags or justifies otherwise.
     ----> The %cmake macro expands well
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
     ----> This is OK
[x]: Development files must be in a -devel package
     ----> This is a special package in this respect
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[N/A]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[N/A]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[N/A]: Package contains systemd file(s) if in need.
[N/A]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[N/A]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Rpmlint
-------
Checking: libsocket_wrapper-1.0.0-1.fc20.x86_64.rpm
          socket_wrapper-1.0.0-1.fc20.src.rpm
libsocket_wrapper.x86_64: W: spelling-error Summary(en_US) unix -> UNIX, Unix, uni
libsocket_wrapper.x86_64: W: shared-lib-calls-exit /usr/lib64/libsocket_wrapper.so.0.0.1 exit@GLIBC_2.2.5
libsocket_wrapper.x86_64: W: devel-file-in-non-devel-package /usr/lib64/pkgconfig/socket_wrapper.pc
libsocket_wrapper.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libsocket_wrapper.so
socket_wrapper.src: W: spelling-error Summary(en_US) unix -> UNIX, Unix, uni
socket_wrapper.src: W: file-size-mismatch socket_wrapper-1.0.0.tar.gz = 37599, https://ftp.samba.org/pub/cwrap/socket_wrapper-1.0.0.tar.gz = 294751
2 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint libsocket_wrapper
libsocket_wrapper.x86_64: W: spelling-error Summary(en_US) unix -> UNIX, Unix, uni
libsocket_wrapper.x86_64: W: shared-lib-calls-exit /usr/lib64/libsocket_wrapper.so.0.0.1 exit@GLIBC_2.2.5
libsocket_wrapper.x86_64: W: devel-file-in-non-devel-package /usr/lib64/pkgconfig/socket_wrapper.pc
libsocket_wrapper.x86_64: W: devel-file-in-non-devel-package /usr/lib64/libsocket_wrapper.so
1 packages and 0 specfiles checked; 0 errors, 4 warnings.
# echo 'rpmlint-done:'



Requires
--------
libsocket_wrapper (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    /usr/bin/pkg-config
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libsocket_wrapper.so.0()(64bit)
    rtld(GNU_HASH)



Provides
--------
libsocket_wrapper:
    libsocket_wrapper
    libsocket_wrapper(x86-64)
    libsocket_wrapper.so.0()(64bit)
    pkgconfig(socket_wrapper)



Unversioned so-files
--------------------
libsocket_wrapper: /usr/lib64/libsocket_wrapper.so

Source checksums
----------------
https://ftp.samba.org/pub/cwrap/socket_wrapper-1.0.0.tar.gz :
  CHECKSUM(SHA256) this package     : 68e956c0e42a7fc06db3b860cbc7e611003159d8b459c2b3069dcd73ebe71bfc
  CHECKSUM(SHA256) upstream package : 04e9edf59df928ebf86837df5b19f90406d46c2a93cd29860508bf6875b7e0c4
diff -r also reports differences


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review --rpm-spec -n socket_wrapper-1.0.0-1.fc20.src.rpm
Buildroot used: fedora-20-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 3 Stephen Gallagher 2014-02-04 10:33:03 UTC
(In reply to Jakub Hrozek from comment #2)

> Issues:
> =======
> - Development (unversioned) .so files in -devel subpackage, if present.
>   Note: Unversioned so-files directly in %_libdir.
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages
>   ---> False positive. This is understandable given the libraries are
>        supposed to be dlopened

If the library is never intended to be linked against, then it belongs in /usr/lib[64]/socket_wrapper/libsocket_wrapper.so

Comment 4 Jakub Hrozek 2014-02-04 11:48:07 UTC
(In reply to Stephen Gallagher from comment #3)
> (In reply to Jakub Hrozek from comment #2)
> 
> > Issues:
> > =======
> > - Development (unversioned) .so files in -devel subpackage, if present.
> >   Note: Unversioned so-files directly in %_libdir.
> >   See: http://fedoraproject.org/wiki/Packaging/Guidelines#DevelPackages
> >   ---> False positive. This is understandable given the libraries are
> >        supposed to be dlopened
> 
> If the library is never intended to be linked against, then it belongs in
> /usr/lib[64]/socket_wrapper/libsocket_wrapper.so

Probably, yeah. In that case we talked with Andreas about adding Libs to the .pc file.

Comment 5 Andreas Schneider 2014-02-04 12:27:25 UTC
Stephen, but then you cannot do LD_PRELOAD=libsocket_wrapper.so cause the dynamic linker will not find it.

Comment 6 Jakub Hrozek 2014-02-04 12:36:40 UTC
(In reply to Andreas Schneider from comment #5)
> Stephen, but then you cannot do LD_PRELOAD=libsocket_wrapper.so cause the
> dynamic linker will not find it.

You could drop a file to /etc/ld.so.conf.d/

Comment 7 Andreas Schneider 2014-02-04 13:45:12 UTC
I know, but I don't really want to do that. It would be the same as putting it to /usr/lib64

Comment 8 Andreas Schneider 2014-02-04 13:46:43 UTC
Only developers will install these libs and they will only be in BuildRequires and never in Requires :)

Comment 9 Jakub Hrozek 2014-02-04 14:18:41 UTC
Hm, the last comment is a fair point. This library has no meaning on a box that is not a devel machine (or a builder, or a test box)

Comment 10 Andreas Schneider 2014-02-04 16:20:29 UTC
Spec URL: http://xor.cryptomilk.org/rpm/socket_wrapper/socket_wrapper.spec
SRPM URL: http://xor.cryptomilk.org/rpm/socket_wrapper/socket_wrapper-1.0.1-1.fc20.src.rpm

ChangeLog of 1.0.1:
  * Added --libs to pkg-config.
  * Added socket_wrapper-config.cmake
  * Fixed a bug packaging the obj directory.

Comment 12 Andreas Schneider 2014-02-11 20:13:33 UTC
Spec URL: http://xor.cryptomilk.org/rpm/socket_wrapper/socket_wrapper.spec
SRPM URL: http://xor.cryptomilk.org/rpm/socket_wrapper/socket_wrapper-1.0.1-3.fc20.src.rpm

- Remove Group
- Remove glibc-devel build requirement
- Do not create a subpackage.

Comment 13 Jakub Hrozek 2014-02-13 17:59:53 UTC
Koji build succeeded:
http://koji.fedoraproject.org/koji/taskinfo?taskID=6527004

Comment 14 Andreas Schneider 2014-02-18 15:02:44 UTC
Ping Jakub :)

Comment 15 Jakub Hrozek 2014-02-19 10:08:20 UTC
Sorry for the delay, I was thinking if we need to move the library to a subdirectory of libdir as Stephen suggested. But I think it's more user-friendly if we don't so that users don't have to search for the library path to preload and can use the wrappers as suggested in the %description.

So I don't have other issues with the package.

Comment 16 Andreas Schneider 2014-02-19 10:50:07 UTC
New Package SCM Request
=======================
Package Name: socket_wrapper
Short Description: A library passing all socket communications trough unix sockets
Owners: asn
Branches: f20 epel7
InitialCC: jhrozek

Comment 17 Gwyn Ciesla 2014-02-19 13:18:45 UTC
Git done (by process-git-requests).

Comment 18 Fedora Update System 2014-02-19 15:40:30 UTC
socket_wrapper-1.0.1-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/socket_wrapper-1.0.1-3.fc20

Comment 19 Fedora Update System 2014-02-22 00:47:43 UTC
socket_wrapper-1.0.1-3.fc20 has been pushed to the Fedora 20 testing repository.

Comment 20 Fedora Update System 2014-03-04 06:38:19 UTC
socket_wrapper-1.0.1-3.fc20 has been pushed to the Fedora 20 stable repository.

Comment 21 Andreas Schneider 2014-08-04 08:45:36 UTC
Package Change Request
======================
Package Name: socket_wrapper
New Branches: el6
Owners: asn jhrozek

Comment 22 Gwyn Ciesla 2014-08-04 12:08:31 UTC
Git done (by process-git-requests).

Comment 23 Fedora Update System 2014-08-07 10:54:46 UTC
socket_wrapper-1.1.0-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/socket_wrapper-1.1.0-2.el6

Comment 24 Fedora Update System 2014-08-08 00:41:32 UTC
socket_wrapper-1.1.0-2.el6 has been pushed to the Fedora EPEL 6 testing repository.

Comment 25 Fedora Update System 2014-08-22 19:16:00 UTC
socket_wrapper-1.1.0-2.el6 has been pushed to the Fedora EPEL 6 stable repository.


Note You need to log in before you can comment on or make changes to this bug.